Rem This File creates load and exec files, launch parallel loads, create indexes and launch parallel execs for the RF1 stored procedure

REM %SETUP_DIR%\CMD_RFs\cmd\RFs\RF1_preCreate.cmd 0 %RUN_ID% RF1_PC %INSERT_PARALLELISM%  %INSERT_EXECUTIONS% %BATCH_SIZE% REM %RF_FLATFILE_DIR% %TABLE_LOAD_PARALLELISM% %FILES_PER_UPDATE_SET%
ECHO STARTPRECREATE

@setlocal ENABLEDELAYEDEXPANSION

REM RF stream num
set TPCH_RF_STREAM_NUM=%1

REM output dir 
set TPCH_RUN_NUM=%2

REM Master log comment 
set TPCH_COMMENT_STR=%3

set TPCH_NUM_RF_EXEC_STREAMS=%4
set TPCH_NUM_RF_EXEC_TOTAL=%5
set TPCH_RF_EXEC_BATCH_SIZE=%6
set TPCH_UF_DIR=%TPCH_RF_FLATFILE_DIR%
set TPCH_NUM_RF_LOAD_STREAMS=%7
set TPCH_NUM_RF_LOAD_FILES=%8


REM ***set RF_EXECUTION_SET=%9

REM *** query the database to determine the updateset to use
sqlcmd -S %TPCH_SERVER% -U %TPCH_USER% -P %TPCH_PASSWORD% -d %TPCH_DATABASE% -i %TPCH_AUTOMATION_SQL%\GetUpdateSet.sql -o %TPCH_AUTOMATION_SQL%UpdateSet.out
for /f "skip=2 tokens=1 skip=2" %%a in (%TPCH_AUTOMATION_SQL%UpdateSet.out) DO SET RF_EXECUTION_SET=%%a


set TPCH_AUTOMATION_PATH=%TPCH_KIT_DIR%\Setup\CMD_RFs
REM the tpch_num_of_files_per_thread should be a calculated value but since we are using hardcode values, anyways
REM This whole list should be parameterized from the Workspace parameters in future.
set TPCH_NUM_OF_THREADS=%4
set TPCH_TOTAL_TRANSACTION_FILES=344
set /A TPCH_NUM_OF_FILES_PER_THREAD=%TPCH_TOTAL_TRANSACTION_FILES% / %TPCH_NUM_OF_THREADS% + 1
set TPCH_INPUT_FOLDER=%TPCH_RF_FLAT_OPTIMAL%


REM set TPCH_AUTOMATION_CMD_PATH=%TPCH_AUTOMATION_PATH%\cmd
REM set TPCH_AUTOMATION_SQL=%TPCH_AUTOMATION_PATH%\sql
REM set TPCH_AUTOMATION_CONFIG=%TPCH_AUTOMATION_PATH%\config
REM set TPCH_AUTOMATION_EXEC=%TPCH_AUTOMATION_PATH%\execs
REM set TPCH_MASTERLOG_NAME=MasterLog.txt
REM set TPCH_SQL_DIR=%systemdrive%\Program Files\Microsoft SQL Server\SQL14_Prerelease\12.0.1800.103
REM set TPCH_SQL_LOG_DIR=%systemdrive%\Program Files\Microsoft SQL Server\SQL14_Prerelease\12.0.1800.103
REM set TPCH_SQL_START_COMMAND_LINE =-c -E -x -T 834 -T 2312 -T 9493
REM set TPCH_SQL_SHELL=sqlcmd -S . -E -I -b -w 65535 -l 60 -y 0
REM set TPCH_EXEC_WINDOW_COLOR=9F

set TPCH_OUTPUT_DIR=%TPCH_OUTPUT_DIR_PREFIX%\%TPCH_RUN_NUM%
if not exist %TPCH_OUTPUT_DIR% md %TPCH_OUTPUT_DIR%
set TPCH_MASTERLOG_FILE=%TPCH_OUTPUT_DIR%\%TPCH_MASTERLOG_NAME%

pushd %TPCH_OUTPUT_DIR%
  
REM create tables and indexes

copy %TPCH_AUTOMATION_SQL%\RF_templ\Create_RF1_Tables.sql 
echo Create_RF1_Tables.sql > create_tables_RF1_%TPCH_RF_STREAM_NUM%.txt

REM copy %TPCH_AUTOMATION_SQL%\RF_templ\Drop_RF1_Tables.sql
REM echo Drop_RF1_Tables.sql > drop_tables_RF1_%TPCH_RF_STREAM_NUM%.txt


copy %TPCH_AUTOMATION_SQL%\RF_templ\Create_RF1_Indices.sql 
echo Create_RF1_Indices.sql > create_indices_RF1_%TPCH_RF_STREAM_NUM%.txt


REM create load files 
set /A LOCAL_CURR_STREAM = 1
:outerLoopLoadCreate
 
	%TPCH_AUTOMATION_EXEC%\GenerateSqlFileNames.exe %LOCAL_CURR_STREAM% %TPCH_NUM_OF_FILES_PER_THREAD% %TPCH_OUTPUT_DIR% %TPCH_INPUT_FOLDER% %TPCH_TOTAL_TRANSACTION_FILES% %TPCH_RF_STREAM_NUM% %TPCH_SERVER% %TPCH_DATABASE% %TPCH_USER% %TPCH_PASSWORD% %TPCH_RUN_METHOD_BCP_OR_BULK_INSERT% %RF_EXECUTION_SET%


set /A LOCAL_CURR_STREAM = %LOCAL_CURR_STREAM% + 1
if %LOCAL_CURR_STREAM% LEQ %TPCH_NUM_OF_THREADS% goto outerLoopLoadCreate


endlocal
