Rem This File creates load and exec files, launch parallel loads, create indexes and launch parallel execs for the RF2 stored procedure
@setlocal ENABLEDELAYEDEXPANSION

REM RF stream num
set TPCH_RF_STREAM_NUM=%1

REM output dir 
set TPCH_RUN_NUM=%2

REM Master log comment 
set TPCH_COMMENT_STR=%3

set TPCH_NUM_RF_EXEC_STREAMS=%4
set TPCH_NUM_RF_EXEC_TOTAL=%5
set TPCH_RF_EXEC_BATCH_SIZE=%6
set TPCH_UF_DIR=%7
set TPCH_NUM_RF_LOAD_STREAMS=%8
set TPCH_NUM_RF_LOAD_FILES=%9

set TPCH_OUTPUT_DIR=%TPCH_OUTPUT_DIR_PREFIX%\%TPCH_RUN_NUM%
if not exist %TPCH_OUTPUT_DIR% md %TPCH_OUTPUT_DIR%
set TPCH_MASTERLOG_FILE=%TPCH_OUTPUT_DIR%\%TPCH_MASTERLOG_NAME%

echo !DATE! !TIME! Start: Executing %TPCH_COMMENT_STR%_STREAM_%TPCH_RF_STREAM_NUM% >> %TPCH_MASTERLOG_FILE%

pushd %TPCH_OUTPUT_DIR%

REM create tables

REM Diff from RF1


call %TPCH_AUTOMATION_CMD_PATH%\execSQLFileList.cmd create_tables_RF2_%TPCH_RF_STREAM_NUM%.txt %TPCH_RUN_NUM% no no no


REM launch parallel loads

	echo !DATE! !TIME! Start: launch_parallel_loads_RF2  >> %TPCH_MASTERLOG_FILE%
	rem call %TPCH_AUTOMATION_CMD_PATH%\RFs\startCollectWrapper.cmd %TPCH_RUN_NUM% %TPCH_COMMENT_STR%_Parallel_loads 

	set TPCH_SEMAPHORE_NAME=Load.%TPCH_RF_STREAM_NUM%.%TPCH_RUN_NUM%
	start %TPCH_AUTOMATION_CMD_PATH%\WaitForSemaphore.cmd %TPCH_SEMAPHORE_NAME% %TPCH_NUM_RF_LOAD_STREAMS% %TPCH_SEMAPHORE_NAME%_all

	set /A LOCAL_CURR_STREAM = 1
:outerLoopLoadRun

	start /MIN %TPCH_AUTOMATION_CMD_PATH%\execSQLFileListSemaphore.cmd %TPCH_SEMAPHORE_NAME% RF2_Load_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt %TPCH_RUN_NUM% no no no

	set /A LOCAL_CURR_STREAM = %LOCAL_CURR_STREAM% + 1
	if %LOCAL_CURR_STREAM% LEQ %TPCH_NUM_RF_LOAD_STREAMS% goto outerLoopLoadRun


	REM wait for all loads to complete 
	%TPCH_AUTOMATION_EXEC%\semaphore -wait %TPCH_SEMAPHORE_NAME%_all -count 1


	rem call %TPCH_AUTOMATION_CMD_PATH%\RFs\stopCollectWrapper.cmd %TPCH_RUN_NUM% %TPCH_COMMENT_STR%_Parallel_loads 
	echo !DATE! !TIME! End: launch_parallel_loads_RF2  >> %TPCH_MASTERLOG_FILE%

REM create indexes 
	echo !DATE! !TIME! Start: create_indexes_RF2  >> %TPCH_MASTERLOG_FILE%
	rem call %TPCH_AUTOMATION_CMD_PATH%\RFs\startCollectWrapper.cmd %TPCH_RUN_NUM% %TPCH_COMMENT_STR%_Create_Indexes 

	call %TPCH_AUTOMATION_CMD_PATH%\execSQLFileList.cmd create_indices_RF2_%TPCH_RF_STREAM_NUM%.txt %TPCH_RUN_NUM% no no no

	rem call %TPCH_AUTOMATION_CMD_PATH%\RFs\stopCollectWrapper.cmd %TPCH_RUN_NUM% %TPCH_COMMENT_STR%_Create_Indexes 
	echo !DATE! !TIME! End: create_indexes_RF2  >> %TPCH_MASTERLOG_FILE%

REM launch parallel execs 

	echo !DATE! !TIME! Start: launch_parallel_execs_RF2  >> %TPCH_MASTERLOG_FILE%
	rem call %TPCH_AUTOMATION_CMD_PATH%\RFs\startCollectWrapper.cmd %TPCH_RUN_NUM% %TPCH_COMMENT_STR%_Parallel_Execs 

	set TPCH_SEMAPHORE_NAME=Exec.%TPCH_RF_STREAM_NUM%.%TPCH_RUN_NUM%
	start %TPCH_AUTOMATION_CMD_PATH%\WaitForSemaphore.cmd %TPCH_SEMAPHORE_NAME% %TPCH_NUM_RF_EXEC_STREAMS% %TPCH_SEMAPHORE_NAME%_all

	set /A LOCAL_CURR_STREAM = 1
:outerLoopExecRun

	start /MIN  %TPCH_AUTOMATION_CMD_PATH%\execSQLFileListSemaphore.cmd %TPCH_SEMAPHORE_NAME% RF2_Execute_List_%TPCH_RF_STREAM_NUM%.%LOCAL_CURR_STREAM%.txt %TPCH_RUN_NUM% no no no

	set /A LOCAL_CURR_STREAM = %LOCAL_CURR_STREAM% + 1
	if %LOCAL_CURR_STREAM% LEQ %TPCH_NUM_RF_EXEC_STREAMS% goto outerLoopExecRun

	REM wait for all execs to complete 

	%TPCH_AUTOMATION_EXEC%\semaphore -wait %TPCH_SEMAPHORE_NAME%_all -count 1

	rem call %TPCH_AUTOMATION_CMD_PATH%\RFs\stopCollectWrapper.cmd %TPCH_RUN_NUM% %TPCH_COMMENT_STR%_Parallel_Execs 
	echo !DATE! !TIME! End: launch_parallel_execs_RF2  >> %TPCH_MASTERLOG_FILE%


REM Drop Tables

REM 	echo !DATE! !TIME! Start: drop_tables_RF2 >> %TPCH_MASTERLOG_FILE%
REM 	call %TPCH_AUTOMATION_CMD_PATH%\execSQLFileList.cmd drop_tables_RF2_%TPCH_RF_STREAM_NUM%.txt %TPCH_RUN_NUM% no no no
REM 	echo !DATE! !TIME! End: drop_tables_RF2 >> %TPCH_MASTERLOG_FILE%

	
	Rem Skip this step this the update step is incremented through step master
	rem call %TPCH_AUTOMATION_CMD_PATH%\execSQLFileList.cmd Increment_Update_Set_RF2_%TPCH_RF_STREAM_NUM%.txt %TPCH_RUN_NUM% no no yes

echo !DATE! !TIME! End: Executing %TPCH_COMMENT_STR%_STREAM_%TPCH_RF_STREAM_NUM% >> %TPCH_MASTERLOG_FILE%

rem sqlcmd -E -i %TPCH_AUTOMATION_SQL%\Dump_Row_Count.sql -o Post_RF2_Row_count_%TPCH_RF_STREAM_NUM%.txt

endlocal
